//+------------------------------------------------------------------+
//|                                            EA Breakout Malam.mq4 |
//|                              Copyright  2009, TradingSytemForex |
//|                                http://www.tradingsystemforex.com |
//|                                modified by Nurhuda Hendra S.     |
//+------------------------------------------------------------------+

#property copyright "Copyright  2009, TradingSytemForex modified by Nurhuda Hendra S."
#property link "http://www.tradingsystemforex.com"

//|----------------------------------------------you can modify this expert
//|----------------------------------------------you can change the name
//|----------------------------------------------you can add "modified by you"
//|----------------------------------------------but you are not allowed to erase the copyrights

#define EAName "EA Breakout Malam"

extern string S1="---------------- Entry Settings";

extern string StartHour="14:00";//|--------------start hour to set the range
extern string EndHour="16:15";//|----------------end hour to set the range
int CloseMode=1;//|-----------------------0=no close, 1=close hour
extern string CloseHour="13:59";//|--------------hour to close trades
extern int SetMinutes=5;//|----------------------max number of minutes to set orders
double MinRangePips=1;//|----------------minimum range in pips
extern double MaxRangePips=70;//|---------------maximum range in pips
extern int MarginRange=6;//|---------------------margin in pips added to the range
extern bool Comments=true;//|--------------------allow comments on chart

extern string S2="---------------- Money Management";

extern double Balance=100.00; //|---------------balance of the account
extern bool RiskMM=true;//|---------------------risk management
extern double RiskPercent=15;//|------------------risk percentage

extern string S3="---------------- Order Management";

extern bool StopLoss=true;//|------------------------stop loss
extern bool TakeProfit=true;//|----------------------take profit
extern int MaxOrders=4;//|-----------------------maximum orders allowed
extern int Slippage=5;//|------------------------slippage
extern int Magic=2009;//|------------------------magic number


extern string S5="---------------- Time Filter";

extern bool TradeOnSunday=true;//|---------------time filter on sunday
extern bool MondayToThursdayTimeFilter=false;//|-time filter the week
extern int MondayToThursdayStartHour=0;//|-------start hour time filter the week
extern int MondayToThursdayEndHour=24;//|--------end hour time filter the week
extern bool FridayTimeFilter=false;//|-----------time filter on friday
extern int FridayStartHour=0;//|-----------------start hour time filter on friday
extern int FridayEndHour=21;//|------------------end hour time filter on friday

datetime PreviousBarTime1;
datetime PreviousBarTime2;

int cnt,Range=0,RangeAfterMargin=0,TimeClose=0,BarsNumber=0,BarsBack=0,TimeStart=0,TimeEnd=0;
double Lots=0,hi=0,lo=0,open_price=0;

//|---------initialization

int init()
{
  if(Comments)Comment("\nLoading...");
  return(0);
}

//|---------deinitialization
/*
int deinit()
{
  return(0);
}
*/
int start()
{

//|---------time filter

   if((TradeOnSunday==false&&DayOfWeek()==0)||(MondayToThursdayTimeFilter&&DayOfWeek()>=1&&DayOfWeek()<=4&&!(Hour()>=MondayToThursdayStartHour&&Hour()<=MondayToThursdayEndHour))||(FridayTimeFilter&&DayOfWeek()==5&&!(Hour()>=FridayStartHour&&Hour()<=FridayEndHour)))
   {
      CloseBuyOrders(Magic);
      CloseSellOrders(Magic);
      return(0);
   }

//|---------signal conditions

   int limit=1;
   for(int i=1;i<=limit;i++)
   {
   
//|---------determine time range high low
 
      TimeStart=StrToTime(StartHour);
      TimeEnd=StrToTime(EndHour);
      TimeClose=StrToTime(CloseHour);
      BarsBack=(((Time[0]-TimeStart)/60)/Period());
      BarsNumber=BarsBack-((Time[0]-(TimeEnd))/60)/Period();
      
      if(BarsNumber==0)
      {
         Comment("Wrong TimeFrame. Switch to lower timeframe or change time range. Exiting...");
         return;
      }

      hi=High[Highest(NULL,0,MODE_HIGH,BarsNumber,BarsBack-BarsNumber+1)]; 
      lo=Low[Lowest(NULL,0,MODE_LOW,BarsNumber,BarsBack-BarsNumber+1)]; 
      Range=(hi-lo)/Point;
      RangeAfterMargin= Range+2*MarginRange;
      
    //|---------close orders at closehour
      
      if (CurTime()-TimeClose>=0&&CurTime()-TimeStart<(TimeEnd-TimeClose)&&CloseMode==1)
      {
         for(cnt=0;cnt<OrdersTotal();cnt++)
         {
            OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
	         if(OrderSymbol()==Symbol())
	         {
		         if(OrderType()==OP_BUYSTOP||OrderType()==OP_SELLSTOP)
		         {
			         if (OrderMagicNumber()==Magic)
			         {
			         OrderDelete(OrderTicket());
			         return;
			         }
		         }
		         if(OrderType()==OP_BUY&&true)
		         {
			         CloseBuyOrders(Magic);
			         return;
		         }
		         if(OrderType()==OP_SELL&&true)
		         {
		            CloseSellOrders(Magic);
			         return;
		         }
	         }
         }
      }
      
    
      string BUY="false";
      string SELL="false";

      if(CurTime()-TimeEnd-900>=0&&CurTime()-TimeEnd-900<=SetMinutes*60&&Range>MinRangePips&&Range<MaxRangePips){BUY="true";SELL="true";}
      
      string SignalBUY="false";
      string SignalSELL="false";
      
      if(BUY=="true") SignalBUY="true";
      if(SELL=="true") SignalSELL="true";
      
   }

//|---------risk management

   if(RiskMM)CalculateMM();


//|---------open orders

   double SL,TP,SLH,TPH,SLP,TPP,OPP;
   int Ticket,TicketH,TicketP,Expire=0;
      
   if(OrdersTotal()<MaxOrders)
   {  
      if (SignalBUY=="true"&&NewBarBuy())
      {
         if(StopLoss){SL=hi+MarginRange*Point-(0.5*RangeAfterMargin)*Point;}else {SL=0;}
         if(TakeProfit){TP=hi+MarginRange*Point+RangeAfterMargin*Point;}else {TP=0;}
                  
         Ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,hi+MarginRange*Point,Slippage,SL,TP,EAName,Magic,Expire,Blue);
      }
      if (SignalSELL=="true"&&NewBarSell())
      {
         if(StopLoss){SL=lo-MarginRange*Point+(0.5*RangeAfterMargin)*Point;}else {SL=0;}
         if(TakeProfit){TP=lo-MarginRange*Point-RangeAfterMargin*Point;}else {TP=0;}
         
         Ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,lo-MarginRange*Point,Slippage,SL,TP,EAName,Magic,Expire,Red);
      }
   }

//|---------not enough money warning

   int err=0;
   if(Ticket<0)
   {
      if(GetLastError()==134)
      {
         err=1;
         Print("Not enough money!");
      }
      return (-1);
   }
   

   if(Comments)
   {
      Comment("\nCopyright  2009, TradingSytemForex",
              "\n\nL o t s                   =  " + DoubleToStr(Lots,2),
              "\nB a l a n c e         =  " + DoubleToStr(AccountBalance(),2),
              "\nE q u i t y            =  " + DoubleToStr(AccountEquity(),2));
   }


   return(0);
}

//|---------close buy orders

int CloseBuyOrders(int Magic)
{
  int result,total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY)
      {
        OrderClose(OrderTicket(),OrderLots(),Bid,3);
        switch(OrderType())
        {
          case OP_BUYLIMIT:
          case OP_BUYSTOP:
          result=OrderDelete(OrderTicket());
        }
      }
    }
  }
  return(0);
}

//|---------close sell orders

int CloseSellOrders(int Magic)
{
  int result,total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL)
      {
        OrderClose(OrderTicket(),OrderLots(),Ask,3);
        switch(OrderType())
        {
          case OP_SELLLIMIT:
          case OP_SELLSTOP:
          result=OrderDelete(OrderTicket());
        }
      }
    }
  }
  return(0);
}

//|---------allow one action per bar

bool NewBarBuy()
{
   if(PreviousBarTime1<Time[0])
   {
      PreviousBarTime1=Time[0];
      return(true);
   }
   return(false);
}

bool NewBarSell()
{
   if(PreviousBarTime2<Time[0])
   {
      PreviousBarTime2=Time[0];
      return(true);
   }
   return(false);
}

//|---------calculate money management

void CalculateMM()
{
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   Lots=(RiskPercent/100)*Balance/(0.5*RangeAfterMargin);
   Lots=MathMin(MaxLots,MathMax(MinLots,Lots));
   if(MinLots<0.1)Lots=NormalizeDouble(Lots,2);
   else
   {
     if(MinLots<1)Lots=NormalizeDouble(Lots,1);
     else Lots=NormalizeDouble(Lots,0);
   }
   if(Lots<MinLots)Lots=MinLots;
   if(Lots>MaxLots)Lots=MaxLots;
   return(0);
}